<script lang="ts">
	import { createEventDispatcher } from 'svelte';
	import {
		controlPositionStore,
		isBeingAdjustedStore,
		touchpadHorizPositionStore,
	} from './store';

	export let width: number = 300;
	export let height: number = 500;
	export let top: number = 0;

	const dispatch = createEventDispatcher();
	let isBeingAdjusted = false;
	let touchpad;
	let position;
	let horizPosition;
	window.addEventListener('pointerup', onWindowPointerUp);
	window.addEventListener(
		'pointermove',
		onWindowPointerMove
	);

	function onPointerDown(event) {
		isBeingAdjusted = true;
		isBeingAdjustedStore.set(isBeingAdjusted);
		position = determinePosition(event);
		horizPosition = determineHorizPosition(event);
	}

	function onWindowPointerUp(event) {
		if (isBeingAdjusted) {
			isBeingAdjusted = false;
			isBeingAdjustedStore.set(isBeingAdjusted);
			position = determinePosition(event);
			horizPosition = determineHorizPosition(event);
			dispatch('changed', position);
		}
	}

	function onWindowPointerMove(event) {
		if (isBeingAdjusted) {
			position = determinePosition(event);
			horizPosition = determineHorizPosition(event);
		}
	}

	function determinePosition(pointerEvent) {
		let touchRect = touchpad.getBoundingClientRect();
		let position =
			(pointerEvent.clientY - touchRect.top) /
			touchRect.height;
		position = Math.min(Math.max(position, 0), 1);
		controlPositionStore.set(position);
		/** Clamp the position between 0 and 1 */
		return position;
	}

	function determineHorizPosition(pointerEvent) {
		let touchRect = touchpad.getBoundingClientRect();
		let position =
			(pointerEvent.clientX - touchRect.left) /
			touchRect.width;
		position = Math.min(Math.max(position, 0), 1);
		touchpadHorizPositionStore.set(position);
		/** Clamp the position between 0 and 1 */
		return position;
	}
</script>

<style>
	.touchpad {
		margin: 0 auto;
		position: absolute;
		top: var(--top);
		left: 50%;
		width: var(--width);
		height: var(--height);
		margin-left: calc(var(--width) * -1 / 2);
		cursor: pointer;
	}
</style>

<div
	bind:this={touchpad}
	on:pointerdown={onPointerDown}
	class="touchpad"
	style="
        --top: {top}px; 
        --width: {width}px; 
        --height: {height}px;" />
